﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Feladat: Elem keresése rendezett számokból álló N elemű sorozatban!
Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
*/
namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, int[] X, out int y)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány számot olvasunk be? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("A(z) " + (i + 1) + ". elem: ");
                X[i] = Convert.ToInt32(Console.ReadLine());
            }
            Console.Error.WriteLine("A keresett elem:");
            y = Convert.ToInt32(Console.ReadLine());
        }

        static bool Eldöntés(int N, int[] X)
        {
            int i = 0;
            while (i < (N - 1) && X[i] <= X[i + 1])
            {
                i++;
            }
            return (i >= (N - 1));
        }

        static void keresIndít(int N, int[] X, int y, ref bool Van, ref int K, ref int cDb)
        {
            int E = 0;
            int U = N - 1;
            Keresés(X, ref E, ref U, y, ref Van, ref K, ref cDb);
        }

        static void Keresés(int[] X, ref int e, ref int u, int y, ref bool Van, ref int K, ref int cDb)
        {
            cDb++;
            if (e > u)
            {
                Van = false;
            }
            else
            {
                K = (e + u) / 2;
                if (X[K] == y)
                {
                    Van = true;
                }
                else if (X[K] < y)
                {
                    int se = K + 1;
                    Keresés(X, ref se, ref u, y, ref Van, ref K, ref cDb);
                }
                else
                {
                    int su = K - 1;
                    Keresés(X, ref e, ref su, y, ref Van, ref K, ref cDb);
                }
            }
        }

        static void Kiírás(int Y, bool Van, int K, int cDb)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            Console.Error.Write("A keresett {0} elem: ",Y);
            if (Van)
            {
                Console.WriteLine("Megtaláltam a(z) {0}. helyen.",(K+1));//lényeg: kimenet, csak ezt írjuk ki Console.WriteLine()-nal
            }
            else
            {
                Console.WriteLine("Nem találtam meg.");//lényeg: kimenet, csak ezt írjuk ki Console.WriteLine()-nal
            }
            Console.WriteLine("Ciklus végrehajtási száma: {0}",cDb);
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            int y;//A keresett elem
            //A tömb deklarálása
            int[] X = new int[MaxN];
            //Kimeneti adatok deklarálása
            bool Van = false;
            int K = -1;
            int cDb = 0;//Ciklusok száma
            //Beolvasás
            Beolvasás(out N, X, out y);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            keresIndít(N, X, y, ref Van, ref K, ref cDb);
            //Kiírás
            Kiírás(y, Van, K, cDb);
        }
    }
}
