﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
/*
Elem keresése rendezett számokból álló NxM-es mátrixban!
Közben számláljuk a keresési ciklus végrehajtási számát (a rekurzív hívások számát)!
*/
namespace feladat
{
    class Program
    {
        static void Beolvasás(out int N, out int M, int[,] X, out int y)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány sorból és oszlopbóp (sor oszlop) áll a mátrix? ");
            string sor = Console.ReadLine();
            string[] adatok = sor.Split(' ');
            N = Convert.ToInt32(adatok[0]);
            M = Convert.ToInt32(adatok[1]);
            //A tömb beolvasása
            for (int i = 0; i < N; i++)
            {
                Console.Error.WriteLine("Írd be a mátrix {0}. sorát, szóközökkel elválasztva!", (i + 1));
                sor = Console.ReadLine();
                adatok = sor.Split(' ');
                for (int j = 0; j < M; j++)
                {
                    X[i,j] = Convert.ToInt32(adatok[j]);
                }
            }
            Console.Error.WriteLine("A keresett elem:");
            y = Convert.ToInt32(Console.ReadLine());
        }

        static void keresIndít(int N, int M, int[,] X, int y, ref bool Van, ref int K, ref int L, ref int cDb)
        {
            int E = 0;
            int U = N - 1;
            SorKeresés(M, X, ref E, ref U, y, ref Van, ref K,ref L, ref cDb);
        }

        static void SorKeresés(int M, int[,] X, ref int e, ref int u, int y, ref bool Van, ref int K, ref int L, ref int cDb)
        {
            cDb++;
            if (e > u)
            {
                Van = false;
            }
            else
            {
                K = (e + u) / 2;
                if (X[K,0] <= y && y <= X[K,M - 1])
                {
                    int se = 0;
                    int su = M - 1;
                    Keresés(X, ref se, ref su, y, ref Van, ref K, ref L, ref cDb);
                }
                else if (X[K,M - 1] < y)
                {
                    int se = K + 1;
                    SorKeresés(M, X, ref se, ref u, y, ref Van, ref K, ref L, ref cDb);
                }
                else
                {
                    int su = K - 1;
                    SorKeresés(M, X, ref e, ref su, y, ref Van, ref K, ref L, ref cDb);
                }
            }
        }

        static void Keresés(int[,] X, ref int e, ref int u, int y, ref bool Van, ref int K, ref int L, ref int cDb)
        {
            cDb++;
            if (e > u)
            {
                Van = false;
            }
            else
            {
                L = (e + u) / 2;
                if (X[K,L] == y)
                {
                    Van = true;
                }
                else if (X[K,L] < y)
                {
                    int se = L + 1;
                    Keresés(X, ref se, ref u, y, ref Van, ref K, ref L, ref cDb);
                }
                else
                {
                    int su = L - 1;
                    Keresés(X, ref e, ref su, y, ref Van, ref K, ref L, ref cDb);
                }
            }
        }

        static void Kiírás(int Y, bool Van, int K, int L, int cDb)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            Console.Error.Write("A keresett {0} elem: ", Y);
            if (Van)
            {
                Console.WriteLine("Megtaláltam a(z) {0},{1} helyen.", (K + 1),(L+1));//lényeg: kimenet, csak ezt írjuk ki Console.WriteLine()-nal
            }
            else
            {
                Console.WriteLine("Nem találtam meg.");//lényeg: kimenet, csak ezt írjuk ki Console.WriteLine()-nal
            }
            Console.WriteLine("Ciklus végrehajtási száma: {0}", cDb);
        }

        static void Main(string[] args)
        {
            //Maximális elemszám
            const int MaxNM = 100;
            //A tömb elemszámának deklarálása
            int N;
            int M;
            int y;//A keresett elem
            //A tömb deklarálása
            int[,] X = new int[MaxNM,MaxNM];
            //Kimeneti adatok deklarálása
            bool Van = false;
            int K = -1;
            int L = -1;
            int cDb = 0;//Ciklusok száma
            //Beolvasás
            Beolvasás(out N, out M, X, out y);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            keresIndít(N, M, X, y, ref Van, ref K, ref L, ref cDb);
            //Kiírás
            Kiírás(y, Van, K, L, cDb);
        }
    }
}
